
public class GapString {
	private static final boolean SCORE = true;
	
	public static void main(String[] args) {
		String s1 = "abcdejkrrrttt", s2 = "aaaaabtttrrrj";

		alignStringsRecur(s1, s2);
	}
	
	public static void alignStrings(String s1, String s2) {
		
		System.out.println("Before:");
		System.out.println("s1 = " + s1);
		System.out.println("s2 = " + s2);
		
		int ind1 = 0, ind2 = 0;
		
		while(ind1 < s1.length() && ind2 < s2.length()) {
			char c1 = s1.charAt(ind1), c2 = s2.charAt(ind2);
			if (c1 != '-' && c2 != '-' && c1 != c2) {
				s1 = insert(s1, '-', ind1);
			}
			ind1++;
			ind2++;
		}
		
		while (s2.length() < s1.length())
			s2 += '-';
		
		System.out.println("\nAfter:");
		System.out.println("s1 = " + s1);
		System.out.println("s2 = " + s2);
	}
	
	private static String fin1, fin2;
	private static int minGaps;
	private static double maxScore;
	public static void alignStringsRecur(String s1, String s2) {
		System.out.println("Before:");
		System.out.println("s1 = " + s1);
		System.out.println("s2 = " + s2);
		fin1 = fin2 = null;
		minGaps = -1;
		maxScore = Integer.MIN_VALUE;
		
		alignStringsRecurHelper(s1, s2, 0, 0, 0);
		
	
		if (SCORE) {
			System.out.printf("\nBest solution: score = %.2f%n", maxScore+0.0000001);
			System.out.println("fin1 = " + fin1);
			System.out.println("fin2 = " + fin2);
		}
		else {
			System.out.println("\nBest solution: " + minGaps + " gaps used");
			System.out.println("fin1 = " + fin1);
			System.out.println("fin2 = " + fin2);
		}
	}
	private static void alignStringsRecurHelper(String s1, String s2, int ind1, int ind2, int numGaps) {
		if (ind1 == s1.length() || ind2 == s2.length()) {
			while (s1.length() < s2.length()) {
				s1 += '-';
				numGaps++;
			}
			while (s2.length() < s1.length()) {
				s2 += '-';
				numGaps++;
			}
			
			if (SCORE) {
				double score = calcScore(s1, s2);
				if (score > maxScore) {
					fin1 = s1;
					fin2 = s2;
					maxScore = score;
				}
			}
			
			else {
				if (minGaps == -1 || (minGaps > -1 && numGaps < minGaps)) {
					fin1 = s1;
					fin2 = s2;
					minGaps = numGaps;
				}
			}
			return;
		}
		
		char c1 = s1.charAt(ind1), c2 = s2.charAt(ind2);
		String temp1 = s1, temp2 = s2;
		if (c1 != '-' && c2 != '-' && c1 != c2) {
			temp1 = insert(s1, '-', ind1);
			alignStringsRecurHelper(temp1, temp2, ind1+1, ind2+1, numGaps+1);
			
			temp2 = insert(s2, '-', ind2);
			alignStringsRecurHelper(s1, temp2, ind1+1, ind2+1, numGaps+1);
		}
		else
			alignStringsRecurHelper(temp1, temp2, ind1+1, ind2+1, numGaps);
	}
	
	
	public static String insert(String s, char c, int ind) {
		return s.substring(0, ind) + c + s.substring(ind); 
	}
	
	// precondition: s1.length() == s2.length()
	public static double calcScore(String s1, String s2) {
		double totPoints = 0;
		for (int i = 0; i<s1.length(); i++) {
			if(s1.charAt(i) == s2.charAt(i)){
				totPoints++;
			}else{
				if(i>0 && (s1.charAt(i-1) == '-' || s2.charAt(i-1) == '-')){
					totPoints-=0.2;
				}else{
					totPoints--;
				}
			}
		}
		return totPoints;
	}
	
}
